#ifndef __CONFIG
#define __CONFIG

#include "fileio.h"

enum{
	kInteriorDisplayOff,
	kInteriorDisplayPlayerOnly,
	kInteriorDisplayCloseCarsOnly,
	kInteriorDisplayAlways,
	kInteriorDisplayNumModes
};

typedef struct{
	int keyID;
	int controllerID1;
	int controllerID2;
	int elementID;
	char identifier[32];
	char controllerIdentifier[256];
}tKeyConfig;

typedef struct{
	int axisControllerID1;
	int axisControllerID2;
	int axisElementID;
	char axisIdentifier[256];
	int min,mid,max;
}tAxisConfig;

typedef struct{
	int screenXSize,screenYSize;
	int windowX,windowY;
	int fullscreen;
	int stencil;
	int performanceStats;
	int textureQuality;
	int soundEnable;
	int maxPlayers;
	int color32Bit;
	int fsaa;
	int guideSigns;
	int motionBlur;
	int allCams;
	int ffb;
	float ffbIntensity;
	int arcade,reverse;
	int showPlayerNames;
	int trackerEnable;
	int carsOnSpeed;
	int demolition;
	int registerLapTimes;
	int metricUnits;
	int challengeData;
	int dbIndex;
	int textureFilter;
	tFileRef lastCar,lastEnemy,lastRoad,lastEnv;
	int numEnemies,automatic,lastLaps,lastColor;
	float soundVolume,musicVolume;
	int maxCarSources;
	float clipFarDistance;
	float hudTransparency;
	int interiorDisplay;
	int cameraMode;
	int numKeys,numAxis,numTaunts;
	char playerName[256];
	char gameName[256];
	char password[256];
	char (*taunts)[256];
	tKeyConfig *keys;
	tAxisConfig *axis;
	tFileRef opponentCars[5];
	int opponentColors[5];
}tSysConfig;

extern tSysConfig *gConfig;

#define kConfigDefault16Name "default16.cfg"
#define kConfigDefault32Name "default32.cfg"
#define kConfigDefault64Name "default64.cfg"
#define kConfigFileName "config.cfg"
#define kConfigFilePName "\pconfig.cfg"
#define kConfigDirName "Redline Folder"
#define kConfigDirPName "\pRedline Folder"

void ConfigInit();

#endif